'use strict';

const vm = require('vm');

module.exports = function createContext({
  globals = {},
  polyfillPath = 'babel-polyfill/dist/polyfill',
  registerPath = 'babel-register',
  babelOptions = {}
} = {}) {
  const context = Object.assign({}, globals, {
    BABEL_REQUIRE_CONTEXT: {
      require,
      babelOptions,
      polyfillPath,
      registerPath
    }
  });

  vm.createContext(context);

  vm.runInContext(`
    BABEL_REQUIRE_CONTEXT.require(BABEL_REQUIRE_CONTEXT.polyfillPath)
    BABEL_REQUIRE_CONTEXT.require(BABEL_REQUIRE_CONTEXT.registerPath)(BABEL_REQUIRE_CONTEXT.babelOptions)
  `, context);

  return function babelRequire(modulePath) {
    context.BABEL_REQUIRE_CONTEXT.modulePath = modulePath;
    vm.runInContext(`
      BABEL_REQUIRE_CONTEXT.exports = BABEL_REQUIRE_CONTEXT.require(BABEL_REQUIRE_CONTEXT.modulePath)
    `, context);
    return context.BABEL_REQUIRE_CONTEXT.exports;
  };
};